clc
clear all

path1=[pwd '\Semenov_Manturovo\Semenov'];
path2=[pwd '\Semenov_Manturovo\Manturovo'];
addpath(path1)
addpath(path2)


oscReadSettings=OscReadSettings();
oscReadSettings.path=path1;
oscReadSettings.encoding='OEM866';
oscReadSettings.filename='dr586f0.cfg';
oscReadSettings.subModeName='N';

FH=FaultOscHandler();
num_current_channels=[11 12 13];% ,     . !!!   !
num_Uchannels=[5 6 7]; % ,    ,     
num_Ichannels=[11 12 13];% ,    ,     

FH.HandleOscillogramm(oscReadSettings,num_current_channels, num_Uchannels, num_Ichannels);

FH %   :  ,    

FH.U_norm
FH.I_norm

FH.U_fault(:,1)
FH.I_fault(:,1)

figure(1)
subplot(3,1,1)
plot(FH.comtrade_data.ana_channels{5}.times,FH.comtrade_data.ana_channels{5}.values,'b');
subplot(3,1,2)
plot(FH.comtrade_data.ana_channels{6}.times,FH.comtrade_data.ana_channels{6}.values,'g');
subplot(3,1,3)
plot(FH.comtrade_data.ana_channels{7}.times,FH.comtrade_data.ana_channels{7}.values,'r');

figure(2)
%%  
num_voltage_channels=[5 6 7];
[F,t]=FH.FrequencyDetector(num_voltage_channels);

hold on
plot(t{1},F{1}, 'b') %   
plot(t{2},F{2}, 'g') %   B
plot(t{3},F{3}, 'r') %   C
