clc
clear all


%{
%   - ,  - .
%  
%An, ch_id, ph, ccbm, uu, a, b
%An - ,  0  999999, 
%ch_id -  , 0-64 , 
%ph  -  , , 0-2 
%ccbm -   (? ?  ). , 0-64 
%uu - , 1-32 , 
%a -  
%b -  
% y=a*x+b, -  .dat, y -  
%skew -   . 1-32 
%min, max  -     (-32767...+32767     -99999...+99999)
%K=primary/secondary=I./I.,   

%{An, ch_id, ph, ccbm, uu, a, b, skew, min, max, primary, secondary, PS}
%PS- Primary, S - Secondary -        
%}

C=COMTRADE();
C.station_name='TEST';
C.rec_dev_id='doomsday_device';

C.path=pwd;
C.filename='TestComtrade';
N=20; %   
C.sys_freq=50;
C.sample_freq=N*C.sys_freq;
C.timemult=1;

dt=1/C.sys_freq/N;
t=0:dt:0.04;
w=2*pi*50;
Ia=500*sin(w*t);
Ib=500*sin(w*t+4*pi/3);
Ic=500*sin(w*t+2*pi/3);

%  -   (0)   (1) 
%   a      .
analog_data={};
% analog_data={ 
%           {Ia,       {1, 'Ia', '','', 'kA', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
%           {Ib,       {2, 'Ib', '','', 'kA', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
%           {Ic,       {3, 'Ic', '','', 'kA', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
%            };

%{
% 
%Dn, ch_id, ph, ccbm, y
%Dn - , 1-6 , 
%ch_id -  , 0-64 , 
%ph  -  , , 0-2 
%ccbm -   (? ?  ). , 0-64 
%y -       ( 0,  1) 
%}
num=length(t);
digital_data={ 
          { ones(num,1),       {1, '', '','', 1},   0 };
          { zeros(num,1),      {2, '', '','', 0},  0 };
           };
           
       
%   -  ! 
% data=analog_data;
data=[analog_data; digital_data];
COMTRADE.CreateComtrade(C,t,data);

oscReadSettings=OscReadSettings;
oscReadSettings.path=pwd;
oscReadSettings.filename='TestComtrade.cfg';
oscReadSettings.encoding='';

out=COMTRADE.ReadComtrade(oscReadSettings);
%out.ana_channels
%out.dig_channels
%out.time
%out.info
%" "   skew    

% plot(out.ana_channels{1}.times, out.ana_channels{1}.values)


