clc
clear %all
close all
warning off

% addpath([pwd '/RelayProtection'])
% addpath([pwd '/OscHandler'])

N=100; %   

% sim('TransformerYD');
sim('TransformerYD.mdl');

%{
%   - ,  - .
%  
%An, ch_id, ph, ccbm, uu, a, b
%An - ,  0  999999, 
%ch_id -  , 0-64 , 
%ph  -  , , 0-2 
%ccbm -   (? ?  ). , 0-64 
%uu - , 1-32 , 
%a -  
%b -  
% y=a*x+b, -  .dat, y -  
%skew -   . 1-32 
%min, max  -     (-32767...+32767     -99999...+99999)
%K=primary/secondary=I./I.,   

%{An, ch_id, ph, ccbm, uu, a, b, skew, min, max, primary, secondary, PS}
%PS- Primary, S - Secondary -        
%}

%%
addpath([pwd '\OscOther'])
C=COMTRADE();
C.station_name='TEST';
C.rec_dev_id='doomsday_device';

C.path=[pwd '\OscOther'];
C.filename='TransformerYD';
% C.filename='SwingModel_R_1_1ph';                                                                                     
%N=100; %   
C.sys_freq=50;
C.sample_freq=N*C.sys_freq;
C.timemult=1;

%  -   (0)   (1) 
%   a      .
analog_data={ 
          {Umes.signals.values(:,1),       {1, 'Ua', '','', 'V', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
          {Umes.signals.values(:,2),       {2, 'Ub', '','', 'V', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
          {Umes.signals.values(:,3),       {3, 'Uc', '','', 'V', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
          
          {Imes.signals.values(:,1),       {4, 'Ia', '','', 'A', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
          {Imes.signals.values(:,2),       {5, 'Ib', '','', 'A', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
          {Imes.signals.values(:,3),       {6, 'Ic', '','', 'A', 1, 0,0,-32768,32767, 1,1 'P'}, 1};
           };

       
digital_data={ 
          { KQC.signals.values(:,1),       {1, '', '','', 1},   0 };
          { KQT.signals.values(:,1),        {2, '', '','', 0},  0 };
           };
                  
data=[analog_data; digital_data];      
%   -  ! 
COMTRADE.CreateComtrade(C,Umes.time,data);


oscReadSettings=OscReadSettings();
oscReadSettings.path=[pwd '\OscOther'];
oscReadSettings.filename='TransformerYD.cfg';
oscReadSettings.encoding='';
% 
out=COMTRADE.ReadComtrade(oscReadSettings);
%out.ana_channels
%out.dig_channels
%out.time
%out.info
%" "   skew    
figure
plot(out.ana_channels{1}.times, out.ana_channels{1}.values)
figure
plot(out.dig_channels{1}.times, out.dig_channels{1}.values)